/*$Header: /CVS/pacs/obsw/spu/devel/source/SPU_Sim/main.cpp,v 1.5 2006/12/04 14:15:00 amazy Exp $*/

#include "stdio.h"
#include "windows.h"
//#include "winuser.h"

#include "VirtuosoSim.h"

int K_SMCSCHANNEL_1 = 1;
int K_SMCSCHANNEL_2 = 2;



DECLARE_VIRTUOSO_TASK(WatchDpu)
DECLARE_VIRTUOSO_TASK(Supervisor)
DECLARE_VIRTUOSO_TASK(Hk)
DECLARE_VIRTUOSO_TASK(DataTransmit)
DECLARE_VIRTUOSO_TASK(CompressionSoftware)
//DECLARE_VIRTUOSO_TASK(SupervisorTest)
DECLARE_VIRTUOSO_TASK(PhotoGenerator)
DECLARE_VIRTUOSO_TASK(SpectroGenerator)




void main(int argc, char **argv)
{

	InitVirtuosoSim(55,"SPU HLSW Simulator 14.07.04", "Version 11. Revision 0. for the SPU-DPU-ICD Issue 5.1 and the DMC-SPU-ICD Issue 3.4");

	SET_FIFO_WIDTH(FIFO_TRANSMIT, 20);    
	SET_FIFO_WIDTH(FIFO_CSW, 40);
//	SET_FIFO_WIDTH(FIFO_SPU_TEST, 20);

	printf("SPU HLSW Ready\n");

	//start tasks
	START_VIRTUOSO_TASK(1, WatchDpu);
	START_VIRTUOSO_TASK(2, Supervisor);
	START_VIRTUOSO_TASK(3, Hk);
	START_VIRTUOSO_TASK(4, DataTransmit);
	START_VIRTUOSO_TASK(8, CompressionSoftware);
//	START_VIRTUOSO_TASK(9, SupervisorTest);
	START_VIRTUOSO_TASK(10, PhotoGenerator);
	START_VIRTUOSO_TASK(11, SpectroGenerator);

	SetThreadPriority(handleThreadHk, THREAD_PRIORITY_HIGHEST);
	SetThreadPriority(handleThreadDataTransmit, THREAD_PRIORITY_HIGHEST);

	while (1) 
	{
		KS_TaskSleep(10000);
	};
};

